/* $Id: mimestream-test.cc,v 1.5 2001/08/22 14:40:47 richard Exp $ -*- C++ -*-
  __   _
  |_) /|  Copyright (C) 2000 Richard Atterer
  | \/|  <richard@atterer.net>
   ` 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2. See
  the file COPYING for details.

  Convert binary data to/from ASCII using Base64 encoding

*/

#include <iostream>
namespace std { }
using namespace std;

#include <mimestream.cc>
//______________________________________________________________________

int main() {
  Base64ostream m(cout);
  char str[] = "Worble, woffle, ";

  for (char* s = str; *s != 0; ++s)
    m << *s;
  m << endl;

  for (char* s = str; *s != 0; ++s)
    m << (*s);
  m.flush(); cout << endl;

  m.write(str, sizeof(str) - 1); m << flush << flush << endl;
  m.write((unsigned char*)str, sizeof(str) - 1); m.flush(); cout << endl;
  m.write((signed char*)str, sizeof(str) - 1); m.flush(); cout << endl;
  m.write((void*)str, sizeof(str) - 1); m.flush(); cout << endl;

  m << str << endl;
  m << (unsigned char*)str; m.flush(); cout << endl;
  m << (signed char*)str; m.flush(); cout << endl;
  m << (void*)str; m.flush(); cout << endl;

  cout << "V29yYmxlLCB3b2ZmbGUsIN/f3w <=" << endl;
  //____________________

  uint32 i = 0xf154ba1f;
  m.put(i).flush();
  cout << endl;
  m << i;
  m.flush();
  cout << endl;
  m << char(0x1f) << (unsigned char)(0xba) << 0xfff54 << '\xf1';
  m.flush();
  cout << endl << "H7pU8Q <=" << endl;

  return 0;
}
