/* $Id: string.cc,v 1.3 2001/08/22 14:55:54 richard Exp $ -*- C++ -*-
  __   _
  |_) /|  Copyright (C) 2001 Richard Atterer
  | \/|  <richard@atterer.net>
   ` 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2. See
  the file COPYING for details.

*/

#include <string.hh>
//______________________________________________________________________

/* Convert an unsigned integer n to decimal chars and append to a
   string. If width!=0, pad the number with character "pad" to the
   specified width. */
string& append(string& s, size_t n, size_t width, char pad) {
  const int BUF_LEN = 40; // Enough room for 128-bit integers. :-)
  static char buf[BUF_LEN];
  char* p = buf + BUF_LEN;
  *--p = '\0';
  if (n == 0) {
    *--p = '0';
  } else {
    while (n != 0) {
      *--p = '0' + (n % 10);
      n /= 10;
    }
  }
  for (int i = width - (buf + BUF_LEN - 1 - p); i > 0; --i)
    s += pad;
  return s += p;
}
